local magentashield_tics = 30*TICRATE

local function MagentaAttackAura(player, deathfx)
	local scale = player.mo.scale/2
	if (deathfx != nil)
		scale = deathfx>>1
	else
		deathfx = 4<<FRACBITS
	end
	local dist = FixedMul(deathfx,32)
	local hang = P_RandomRange(0,7) * ANGLE_45
	local vang = P_RandomRange(0,7) * ANGLE_45
	local orb = P_SpawnMobj(
		player.mo.x + (dist * cos(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.y + (dist * sin(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.z + (player.mo.height>>1) + (dist * cos(vang+ANGLE_180)),
		MT_THOK
	)
	orb.scale = scale
	orb.momx = ((dist/8) * cos(hang)) + ((dist/8) * sin(vang))
	orb.momy = ((dist/8) * sin(hang)) + ((dist/8) * sin(vang))
	orb.momz = (dist/8) * cos(vang)
	orb.fuse = 8
	orb.color = SKINCOLOR_MASTER
	orb.colorized = true
	orb.blendmode = AST_ADD
	orb.target = player.mo
	orb.tracer = player.mo
end

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.playerstate == PST_LIVE
			//Magenta Emerald
			if not (player.checkstefan)
				player.checkstefan = 0
			end
			if player.mo.skin == "stefan"
				player.checkstefan = 2
			else
				if player.checkstefan > 0
					player.checkstefan = $1 - 1
				end
			end
			if player.mo.skin == "stefan"
				if player.checkstefan >= 1
					if not (player.magentaemerald) or not (player.magentaemerald.valid)
						player.magentaemerald = P_SpawnMobj(
							player.mo.x + P_ReturnThrustX(player.mo, player.drawangle + ANGLE_45, -20*FRACUNIT), 
							player.mo.y + P_ReturnThrustY(player.mo, player.drawangle + ANGLE_45, -20*FRACUNIT),
							player.mo.z + player.mo.height/2,
							MT_MAGENTAEMERALD
						)
						player.magentaemerald.target = player.mo
					end
					if P_LookForEnemies(player, false) and (player.magentaemerald) and not (player.magentaemerald.tracer) and not (player.checkstefan)
						player.magentaemerald.tracer = P_LookForEnemies(player, false)
					end
				end
			else
				if player.magentaemerald and player.magentaemerald.valid then
					local dd = P_SpawnGhostMobj(player.magentaemerald)
					dd.blendmode = AST_ADD
					dd.fuse = TICRATE/3
					dd.destscale = 0
					dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
					P_KillMobj(player.magentaemerald)
					player.magentaemerald = nil
				end
			end
			//
			local apex = FixedMul(4*player.mo.scale, min(skins[player.mo.skin].jumpfactor, FRACUNIT)) --Determine jump apex,
			if player.mo.eflags & MFE_UNDERWATER --Correct for being underwater,
				apex = 117*$/200
			end
			//Magenta Magic
			if player.mo.skin == "stefan"
				if player.playerstate == PST_LIVE
					if not (player.mo.stefanmenu)
						player.mo.stefanmenu = 0
					end
					if not (player.stefannothing)
						player.stefannothing = 0
					end
					if not (player.mo.stefanmenu_press)
						player.mo.stefanmenu_press = 0
					end
					if not (player.mo.stefanaccept)
						player.mo.stefanaccept = 0
					end
					if not (player.mo.stefancancel)
						player.mo.stefancancel = 0
					end
					if not (player.mo.stefanmenu_press2)
						player.mo.stefanmenu_press2 = 0
					end
					if not (player.mo.stefanpoint)
						player.mo.stefanpoint = 0
					end
					if player.mo.stefanpoint > 5
						player.mo.stefanpoint = 1
					end
					if player.mo.stefanpoint == 0
						player.mo.stefanpoint = 5
					end
					if not (player.stefanability)
						 player.stefanability = 0
					end
					if player.stefanability >= 2
						player.charability = CA_FLY
					else
						player.charability = CA_HOMINGTHOK
					end
					if not (player.stefanshield)
						player.stefanshield = 0
					end
					if not (player.stefanfire)
						player.stefanfire = 0
					end
					if not (player.stefanability3)
						player.stefanability3 = 0
					end
					//Dash Fly
					if not (player.mo.dashfly)
						player.mo.dashfly = 0
					end
					if player.mo.dashfly > 0
						player.mo.dashfly = $1 - 1
					end
					if player.mo.dashfly > 0 and not P_PlayerInPain(player) and not (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						player.mo.state = S_PLAY_FLY
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						local dd = P_SpawnGhostMobj(player.mo)
						dd.blendmode = AST_ADD
						dd.fuse = TICRATE/3
						dd.destscale = 0
						dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
						if not (player.mo.eflags & MFE_UNDERWATER)
							if (leveltime % 3) == 1
								S_StartSound(player.mo, sfx_putput)
							end
						end
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 10*FRACUNIT/2, false)
						else
							P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
						end
					end
					if player.mo.dashfly > 0 and not P_PlayerInPain(player) and (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						player.mo.state = S_PLAY_WALK
						player.mo.dashfly = 0
					end
					if player.mo.dashfly == 1 and not P_PlayerInPain(player) and not (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						if player.stefanability == 1
							player.mo.stefanfly = 7*TICRATE
						end
						player.mo.stfnslowfall = 1
					end
					//Slow Fall
					if not (player.mo.stfnslowfall)
						player.mo.stfnslowfall = 0
					end
					if not (player.mo.stefanfly)
						player.mo.stefanfly = 0
					end
					if player.mo.stefanfly > 0
						player.mo.stefanfly = $1 - 1
					end
					if player.mo.stfnslowfall == 1 and not P_PlayerInPain(player) and not (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						if player.stefanability == 1
							if player.mo.stefanfly > 0
								if not (player.mo.eflags & MFE_UNDERWATER)
									if (leveltime % 3) == 1
										S_StartSound(player.mo, sfx_putput)
									end
								end
								if (player.cmd.buttons & BT_JUMP)
									if (player.mo.eflags & MFE_UNDERWATER)
										P_SetObjectMomZ(player.mo, 6*FRACUNIT/2, false)
									else
										P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
									end
								elseif (player.cmd.buttons & BT_SPIN)
									if (player.mo.eflags & MFE_UNDERWATER)
										P_SetObjectMomZ(player.mo, -9*FRACUNIT/2, false)
									else
										P_SetObjectMomZ(player.mo, -9*FRACUNIT, false)
									end
								else
									if (player.mo.eflags & MFE_UNDERWATER)
										P_SetObjectMomZ(player.mo, -1*FRACUNIT/2, false)
									else
										P_SetObjectMomZ(player.mo, -1*FRACUNIT, false)
									end
								end
							else
								player.mo.state = S_PLAY_FALL
								player.mo.stfnslowfall = 0
							end
						else
							if (player.cmd.buttons & BT_JUMP)
								player.mo.state = S_PLAY_FLY
								if not (player.mo.eflags & MFE_UNDERWATER)
									if (leveltime % 3) == 1
										S_StartSound(player.mo, sfx_putput)
									end
								end
								if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
								or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
									if (leveltime & 1) == 1
										P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
									end
								elseif player.mo.momz > -apex and player.mo.momz < apex
									P_SetObjectMomZ(player.mo, -3*FRACUNIT)
								else
									P_SetObjectMomZ(player.mo, -3*FRACUNIT)
								end
							else
								player.mo.state = S_PLAY_FALL
								player.mo.stfnslowfall = 0
							end
						end
					end
					if player.mo.stfnslowfall > 0 and not P_PlayerInPain(player) and (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						player.mo.state = S_PLAY_WALK
						player.mo.stfnslowfall = 0
					end
					//Stamina
					if not (player.mo.stefanstamina)
						player.mo.stefanstamina = 0
					end
					if player.mo.stefanstamina >= 0
						if (leveltime % 22 == 0)
							if player.mo.stefanstamina <= 99
								player.mo.stefanstamina = $1 + 3
							end
						end
					end
					if player.mo.stefanstamina > 99
						player.mo.stefanstamina = 99
					end
					if not (player.mo.stefancheckdamage)
						player.mo.stefancheckdamage = 0
					end
					//Magenta Shield Pain
					if not (player.mo.magentashield_paintics)
						player.mo.magentashield_paintics = 0
					end
					if player.mo.magentashield_paintics > 0
						player.mo.magentashield_paintics = $1 - 1
					end
					if player.mo.magentashield_paintics > 0
						player.mo.state = S_PLAY_PAIN
						player.pflags = $1 & ~PF_APPLYAUTOBRAKE
						P_ResetPlayer(player)
						player.powers[pw_nocontrol] = 2
						if (P_IsObjectOnGround(player.mo))
							S_StartSound(player.mo, sfx_s3k49)
							if (player.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(player.mo, 4*FRACUNIT/2, false)
							else
								P_SetObjectMomZ(player.mo, 4*FRACUNIT, false)
							end
						end
					end
					//
					if P_PlayerInPain(player) or (CBW_Battle and (player.tumble != nil and player.tumble > 0))
					or player.mo.state == S_PLAY_PAIN or player.mo.sprite2 == SPR2_PAIN or (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
						player.mo.stefancheckdamage = 1 player.mo.magentashield_paintics = 0
						//Abilities
						player.mo.dashfly = 0
						player.mo.stfnslowfall = 0
						//
					else
						player.mo.stefancheckdamage = 0
					end
					local CR_Table = {
						CR_GENERIC = 0, CR_PLAYER = 1, CR_NIGHTSFALL = 2, CR_BRAKGOOP = 3, CR_ROPEHANG = 4, CR_ZOOMTUBE = 5, CR_MACESPIN = 6,
						CR_MINECART = 7, CR_ROLLOUT = 8, CR_PTERABYTE = 9, CR_DUSTDEVIL = 10
					}
					for i = 0, #CR_Table, 1 do
						if player.powers[pw_carry] == CR_Table[i]
							player.mo.stefancheckdamage = 1 player.mo.magentashield_paintics = 0
							//Abilities
							player.mo.dashfly = 0
							player.mo.stfnslowfall = 0
							//
						end
					end
					if player.mo.stefancheckdamage == 1
						if player.mo.magentashield > 0
							player.mo.mshld_tics = magentashield_tics
							player.mo.magentashield = 0
						end
						if player.mo.matack > 0
							player.mo.matak_tics = 10*TICRATE
							player.mo.matack = 0
						end
						if player.mo.magentathok > 0
							player.mo.mgnthktics = 10*TICRATE
							player.mo.magentathok = 0
						end
					end
					//Magenta Shield
					if not (player.mo.magentashield)
						player.mo.magentashield = 0
					end
					if player.mo.magentashield > 0
						player.mo.magentashield = $1 - 1
					end
					if player.mo.magentashield > 0
						player.mo.stefanctm1 = 1
					end
					if player.mo.magentashield == 1
						player.mo.mshld_tics = magentashield_tics
					end
					if not (player.mo.mshld_tics)
						player.mo.mshld_tics = 0
					end
					if player.mo.mshld_tics > 0
						player.mo.mshld_tics = $1 - 1
					end
					if player.mo.mshld_tics >= 1
						player.mo.stefanctm1 = 1
					end
					if not (player.mo.stefanctm1)
						player.mo.stefanctm1 = 0
					end
					if not (player.cmd.buttons & BT_CUSTOM1)
						player.mo.stefanctm1 = 0
					end
					if (player.cmd.buttons & BT_CUSTOM1)
					and not (player.pflags & PF_STASIS)
					and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
					and player.mo.stefanctm1 == 0
					and not player.exiting
					and not player.mo.mshld_tics
					and not player.mo.stefancheckdamage
					and not player.mo.magentashield
					and player.mo.stefanstamina >= 50
					and not P_PlayerInPain(player) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						if player.stefanshield == 1
							player.mo.stefanstamina = $1 - 50
							player.rings = $1 + 10
							S_StartSound(player.mo, sfx_s3k78)
							player.mo.mshld_tics = 200*TICRATE
						else
							player.mo.stefanstamina = $1 - 50
							S_StartSound(player.mo, sfx_s3k78)
							local magentashield_start = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
							magentashield_start.color = SKINCOLOR_YELLOW
							magentashield_start.colorized = true
							magentashield_start.blendmode = AST_ADD
							magentashield_start.scale = player.mo.scale
							magentashield_start.destscale = player.mo.scale*8
							magentashield_start.target = player.mo
							magentashield_start.sprite = SPR_SCFE
							magentashield_start.frame = A|FF_FULLBRIGHT
							player.tracer = magentashield_start
							magentashield_start.eflags = player.mo.eflags&MFE_VERTICALFLIP
							local magentashield = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_MAGENTASHIELD)
							magentashield.color = SKINCOLOR_YELLOW
							magentashield.colorized = true
							magentashield.blendmode = AST_ADD
							magentashield.target = player.mo
							player.tracer = magentashield
							player.mo.magentashield = 5*TICRATE
						end
					end
					//Magenta Attack
					if not (player.mo.matak_tics)
						player.mo.matak_tics = 0
					end
					if player.mo.matak_tics > 0
						player.mo.matak_tics = $1 - 1
					end
					if player.mo.matak_tics >= 1
						player.mo.stefanctm2 = 1
					end
					if not (player.mo.matack)
						player.mo.matack = 0
					end
					if player.mo.matack > 0
						player.mo.matack = $1 - 1
					end
					if player.mo.matack > 0
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						player.mo.momx = 8*$/9 player.mo.momy = 8*$/9
						MagentaAttackAura(player)
						if (leveltime & 3) == 1
							S_StartSound(player.mo, sfx_s3k5c)
							player.mo.state = S_PLAY_SPINDASH
						end
					end
					if player.mo.matack == 1
						S_StartSound(player.mo, sfx_tblr)
						local a = P_SpawnGhostMobj(player.magentaemerald)
						a.color = SKINCOLOR_MASTER
						a.colorized = true
						a.blendmode = AST_ADD
						a.sprite = SPR_SCFE
						a.scale = player.mo.scale/2
						a.frame = A|FF_FULLBRIGHT
						player.mo.state = S_PLAY_FALL
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 9*FRACUNIT/2, false)
							P_InstaThrust(player.mo, player.drawangle, -8*FRACUNIT/2)
						else
							P_SetObjectMomZ(player.mo, 9*FRACUNIT, false)
							P_InstaThrust(player.mo, player.drawangle, -8*FRACUNIT)
						end
						if player.stefanfire == 1
							P_SPMAngle(player.mo, MT_FBOMB, player.mo.angle, 1)
						else
							P_SPMAngle(player.mo, MT_MGNTATTACK, player.mo.angle, 1)
						end
						player.mo.matak_tics = 10*TICRATE
					end
					if not (player.mo.stefanctm2)
						player.mo.stefanctm2 = 0
					end
					if not (player.cmd.buttons & BT_CUSTOM2)
						player.mo.stefanctm2 = 0
					end
					if (player.cmd.buttons & BT_CUSTOM2)
					and not (player.pflags & PF_STASIS)
					and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
					and player.mo.stefanctm2 == 0
					and not player.exiting
					and not player.mo.stefancheckdamage
					and not player.mo.matack
					and player.mo.stefanstamina >= 30
					and not player.mo.magentathok
					and not P_PlayerInPain(player) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						player.mo.stefanstamina = $1 - 30
						player.mo.dashfly = 0
						player.mo.stfnslowfall = 0
						S_StartSound(player.mo, sfx_s3k78)
						player.mo.stefanctm2 = 1
						player.mo.matack = 3*TICRATE
					end
					//Magenta Thok
					if not (player.mo.stefanctm3)
						player.mo.stefanctm3 = 0
					end
					if not (player.cmd.buttons & BT_CUSTOM3)
						player.mo.stefanctm3 = 0
					end
					if not (player.mo.magentathok)
						player.mo.magentathok = 0
					end
					if player.mo.magentathok > 0
						player.mo.magentathok = $1 - 1
					end
					if player.mo.magentathok > 0
						player.pflags = $1|PF_THOKKED
						player.pflags = $|PF_FULLSTASIS
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						player.mo.state = S_PLAY_ROLL
						local dd = P_SpawnGhostMobj(player.mo)
						dd.blendmode = AST_ADD
						dd.fuse = TICRATE/3
						dd.destscale = 0
						dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
						local dd = P_SpawnGhostMobj(player.magentaemerald)
						dd.blendmode = AST_ADD
						dd.fuse = TICRATE/3
						dd.destscale = 0
						dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
						if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
						or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
							if (leveltime & 1) == 1
								P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
							end
						elseif player.mo.momz > -apex and player.mo.momz < apex
							player.mo.momz = 0
						end
						player.powers[pw_nocontrol] = 2
						if (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.drawangle, 50*FRACUNIT/2)
						else
							P_InstaThrust(player.mo, player.drawangle, 50*FRACUNIT)
						end
						player.mo.stefanctm3 = 1
					end
					if player.mo.magentathok == 1
						player.mo.state = S_PLAY_FALL
						player.pflags = $1 & ~PF_JUMPED
						player.mo.mgnthktics = 10*TICRATE
					end
					if not (player.mo.mgnthktics)
						player.mo.mgnthktics = 0
					end
					if player.mo.mgnthktics > 0
						player.mo.mgnthktics = $1 - 1
					end
					if player.mo.mgnthktics > 0
						player.mo.stefanctm3 = 1
					end
					if not (player.mo.stefanport)
						player.mo.stefanport = 0
					end
					if player.mo.stefanport > 0
						player.mo.stefanport = $1 - 1
					end
					if player.mo.stefanport > 0
						player.shieldscale = 0
						player.mo.flags2 = $1|MF2_DONTDRAW
						P_SetObjectMomZ(player.mo, 0*FRACUNIT)
						player.mo.state = S_PLAY_FALL
						player.pflags = $|PF_FULLSTASIS
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						player.powers[pw_nocontrol] = 2
						if (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.drawangle, 42*FRACUNIT/2)
						else
							P_InstaThrust(player.mo, player.drawangle, 42*FRACUNIT)
						end
					else
						if player.shieldscale < skins[player.mo.skin].shieldscale
							player.shieldscale = $+(skins[player.mo.skin].shieldscale/7)
						elseif player.shieldscale > skins[player.mo.skin].shieldscale
							player.shieldscale = skins[player.mo.skin].shieldscale
						end
					end
					if player.mo.stefanport == 1
						local dd = P_SpawnGhostMobj(player.mo)
						dd.blendmode = AST_ADD
						dd.fuse = TICRATE/3
						dd.destscale = 0
						dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
						dd.tics = 32
						player.mo.flags2 = $1 & ~MF2_DONTDRAW
						P_SetObjectMomZ(player.mo, 0*FRACUNIT)
						player.mo.state = S_PLAY_FALL
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						if (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.drawangle, 36*FRACUNIT/2)
						else
							P_InstaThrust(player.mo, player.drawangle, 36*FRACUNIT)
						end
					end
					if (player.cmd.buttons & BT_CUSTOM3)
					and not (player.pflags & PF_STASIS)
					and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
					and player.mo.stefanctm3 == 0
					and not player.exiting
					and not player.mo.mgnthktics
					and not player.mo.magentathok
					and not player.mo.matack
					and not (player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_SWIM or player.mo.state == S_PLAY_FLY_TIRED)
					and player.mo.stefanstamina >= 15
					and not P_PlayerInPain(player) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						if player.stefanability3 == 1
							if not (player.pflags & PF_THOKKED)
								player.mo.stefanstamina = $1 - 15
								local dd = P_SpawnGhostMobj(player.mo)
								dd.blendmode = AST_ADD
								dd.fuse = TICRATE/3
								dd.destscale = 0
								dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
								dd.tics = 32
								S_StartSound(player.mo, sfx_cdfm62)
								player.mo.stefanport = 15
								player.mo.mgnthktics = 15*TICRATE
								player.pflags = $1|PF_THOKKED
							end
						else
							player.mo.stefanstamina = $1 - 15
							player.mo.dashfly = 0
							player.mo.stfnslowfall = 0
							player.mo.momz = 0
							if (P_IsObjectOnGround(player.mo))
								if (player.mo.eflags & MFE_UNDERWATER)
									P_SetObjectMomZ(player.mo, 4*FRACUNIT/2, false)
								else
									P_SetObjectMomZ(player.mo, 4*FRACUNIT, false)
								end
							end
							local mgntthok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
							mgntthok.color = player.mo.color
							mgntthok.colorized = true
							mgntthok.blendmode = AST_ADD
							mgntthok.scale = player.mo.scale
							mgntthok.destscale = player.mo.scale*8
							mgntthok.target = player.mo
							mgntthok.sprite = SPR_SCFE
							mgntthok.frame = A|FF_FULLBRIGHT
							player.tracer = mgntthok
							mgntthok.eflags = player.mo.eflags&MFE_VERTICALFLIP
							S_StartSound(player.mo, sfx_thok)
							S_StartSound(player.mo, sfx_cdfm62)
							player.mo.magentathok = 25
						end
					end
				end
			end
			//
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "stefan" and player.playerstate == PST_LIVE)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
	and not player.mo.dashfly
	and not player.mo.stfnslowfall
	and not player.mo.matack
	and not player.mo.magentathok
	and not (player.pflags & PF_THOKKED)
	and not P_LookForEnemies(player)
		if not player.mo.matack
			if player.stefanability < 2
				S_StartSound(player.mo, sfx_spin)
				player.mo.dashfly = 15
				player.pflags = $1|PF_THOKKED
			end
		else
			player.pflags = $1|PF_THOKKED
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo.target and mo.target.valid
		local z
		if mo.eflags & MFE_VERTICALFLIP
			z = mo.target.z-mo.target.height/2
		else
			z = mo.target.z
		end
		if mo.type == MT_MAGENTASHIELD
			P_MoveOrigin(mo, mo.target.x, mo.target.y, z)
		else
			P_MoveOrigin(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
		end
		if not mo.target.magentashield
			P_RemoveMobj(mo)
		end
	end
	if mo and mo.valid and mo.type == MT_MAGENTASHIELD
		mo.color = SKINCOLOR_YELLOW
		mo.colorized = true
		mo.blendmode = AST_ADD
		mo.shadowscale = 0
		if mo.target and mo.target.player
			if mo.target.player.playerstate == PST_DEAD
			or P_PlayerInPain(mo.target.player)
			or (CBW_Battle and (mo.target.player.tumble != nil and mo.target.player.tumble > 0)) //Tumble Fix
			or mo.target.player.state == S_PLAY_DEAD
			or mo.target.player.state == S_PLAY_DRWN
			or mo.target.player.state == S_PLAY_PAIN //xd
			or mo.target.player.state == S_PLAY_STUN //Why not?
				P_RemoveMobj(mo)
			end
		end
	end
end, MT_MAGENTASHIELD)

addHook("MobjThinker", function(mo)
	if not (mo.target)
		P_KillMobj(mo)
		return
	end
	if mo and mo.valid
		if mo.target.player.playerstate == PST_LIVE
			if not mo.target.player.checkstefan
				P_KillMobj(mo)
				return
			end
			mo.angle = mo.target.player.drawangle or mo.target.angle
			mo.eflags = mo.target.eflags&MFE_VERTICALFLIP
			mo.tics = 5
			if mo.target.stefanport > 0
				mo.sprite = SPR_NULL
			else
				mo.sprite = SPR_STPN
			end
			mo.scale = mo.target.scale
			mo.frame = A|FF_FULLBRIGHT
			mo.color = mo.target.color
			if (mo.tracer == nil)
				P_MoveOrigin(
					mo, 
					mo.target.x + P_ReturnThrustX(mo.target, mo.target.player.drawangle + ANGLE_45, -20*FRACUNIT), 
					mo.target.y + P_ReturnThrustY(mo.target, mo.target.player.drawangle + ANGLE_45, -20*FRACUNIT),
					mo.target.z + mo.target.height/2  - FixedMul(12*FRACUNIT, mo.target.scale) + (2 * cos(ANG10*leveltime))
				)
			else
				P_MoveOrigin(
					mo, 
					mo.target.x + P_ReturnThrustX(mo.target, mo.target.player.drawangle + ANGLE_45, -20*FRACUNIT), 
					mo.target.y + P_ReturnThrustY(mo.target, mo.target.player.drawangle + ANGLE_45, -20*FRACUNIT),
					mo.target.z + mo.target.height/2 + (2 * cos(ANG10*leveltime))
				)
			end
		else
			local dd = P_SpawnGhostMobj(mo)
			dd.blendmode = AST_ADD
			dd.fuse = TICRATE/3
			dd.destscale = 0
			dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
		end
	end
end, MT_MAGENTAEMERALD)

addHook("MobjThinker", function(mo)
	mo.rollangle = $+ANG20
	mo.color = SKINCOLOR_MASTER
	mo.colorized = true
	mo.blendmode = AST_ADD
	local f = P_SpawnGhostMobj(mo)
	f.scale = mo.scale
	f.fuse = TICRATE/3
	f.state = S_MGNTATTACK_SPIN
	f.color = SKINCOLOR_MASTER
	f.colorized = true
	f.blendmode = AST_ADD
	f.frame = $|(FF_TRANS10 * (10 - min(f.fuse, 10)))
	P_InstaThrust(mo, mo.angle, 80*FRACUNIT)
end, MT_MGNTATTACK)

addHook("ShouldDamage", function(mo, inflictor, source, damage, damagetype)
	if mo and mo.valid and mo.skin == "stefan" and not mo.player.powers[pw_carry]
		if mo.magentashield
			if inflictor and inflictor.valid
				if inflictor.flags & MF_BOXICON
				or damagetype & DMG_DEATHMASK
					return
				end
				mo.player.powers[pw_flashing] = 3*TICRATE
				mo.mshld_tics = magentashield_tics
				if (mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(mo, 9*FRACUNIT/2, false)
					P_InstaThrust(mo, mo.angle, -8*FRACUNIT/2)
				else
					P_SetObjectMomZ(mo, 9*FRACUNIT, false)
					P_InstaThrust(mo, mo.angle, -8*FRACUNIT)
				end
				mo.magentashield_paintics = 25
				mo.magentashield = 0
				return false
			end
		end
		if mo.stefanport
			return false
		end
	end
end, MT_PLAYER)

addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "stefan")
		if player.mo.magentathok then
			return true
		end
    end
end)

addHook("MobjDamage", function(mo, inf, source)
	if not (mo.flags & MF_BOSS)
		return
	end
	if mo and mo.valid
		if source and source.valid and source.player and source.skin == "stefan"
			if source.magentathok
				if (mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(mo, 9*FRACUNIT/2, false)
					P_InstaThrust(mo, mo.angle, -8*FRACUNIT/2)
				else
					P_SetObjectMomZ(mo, 9*FRACUNIT, false)
					P_InstaThrust(mo, mo.angle, -8*FRACUNIT)
				end
				source.magentathok = 0
			end
		end
	end
end)

COM_AddCommand("stefanmenu", function(player)
    if mapheaderinfo[gamemap].armagood then return end
    if not (player.powers[pw_carry] or G_IsSpecialStage() or (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS))
        if player.mo.stefanmenu == 0
            player.mo.stefanpoint = 1
            player.mo.stefanmenu = 1
        elseif player.mo.stefanmenu == 1
            player.mo.stefanmenu = 0
        end
    end
end)

addHook("PreThinkFrame", function()
	for player in players.iterate do
		if player.mo and player.mo.valid and player.mo.skin == "stefan"
			if player.mo.stefanmenu == 1
				if (player.cmd.forwardmove > 25)
				and player.mo.stefanmenu_press == 0
					player.mo.stefanpoint = $1 + 1
					
					player.mo.stefanmenu_press = 1
				elseif (player.cmd.forwardmove < -25)
				and player.mo.stefanmenu_press2 == 0
					player.mo.stefanpoint = $1 - 1
					
					player.mo.stefanmenu_press2 = 1
				end
				//Ability 1
				if (player.cmd.buttons & BT_JUMP)
				and player.mo.stefanpoint == 1
				and player.mo.stefanaccept == 0
				and player.stefanability == 0
					player.stefanability = 1
					
					player.mo.stefanaccept = 1
				elseif (player.cmd.buttons & BT_JUMP)
				and player.mo.stefanpoint == 1
				and player.mo.stefanaccept == 0
				and player.stefanability == 1
					player.stefanability = 2
					
					player.mo.stefanaccept = 1
				elseif (player.cmd.buttons & BT_SPIN)
				and player.mo.stefanpoint == 1
				and player.mo.stefancancel == 0
				and player.stefanability == 2
					player.stefanability = 1
					
					player.mo.stefancancel = 1
				elseif (player.cmd.buttons & BT_SPIN)
				and player.mo.stefanpoint == 1
				and player.mo.stefancancel == 0
				and player.stefanability == 1
					player.stefanability = 0
					
					player.mo.stefancancel = 1
				//Ability 2
				elseif (player.cmd.buttons & BT_JUMP)
				and player.mo.stefanpoint == 2
				and player.mo.stefanaccept == 0
				and player.stefanshield == 0
					player.stefanshield = 1
					
					player.mo.stefanaccept = 1
				elseif (player.cmd.buttons & BT_SPIN)
				and player.mo.stefanpoint == 2
				and player.mo.stefancancel == 0
				and player.stefanshield == 1
					player.stefanshield = 0
					
					player.mo.stefancancel = 1
				//Ability 3
				elseif (player.cmd.buttons & BT_JUMP)
				and player.mo.stefanpoint == 3
				and player.mo.stefanaccept == 0
				and player.stefanfire == 0
					player.stefanfire = 1
					
					player.mo.stefanaccept = 1
				elseif (player.cmd.buttons & BT_SPIN)
				and player.mo.stefanpoint == 3
				and player.mo.stefancancel == 0
				and player.stefanfire == 1
					player.stefanfire = 0
					
					player.mo.stefancancel = 1
				//Ability 4
				elseif (player.cmd.buttons & BT_JUMP)
				and player.mo.stefanpoint == 4
				and player.mo.stefanaccept == 0
				and player.stefanability3 == 0
					player.stefanability3 = 1
					
					player.mo.stefanaccept = 1
				elseif (player.cmd.buttons & BT_SPIN)
				and player.mo.stefanpoint == 4
				and player.mo.stefancancel == 0
				and player.stefanability3 == 1
					player.stefanability3 = 0
					
					player.mo.stefancancel = 1
				//Super Color
				elseif (player.cmd.buttons & BT_JUMP)
				and player.mo.stefanpoint == 5
				and player.mo.stefanaccept == 0
				and player.stefannothing == 0
					player.stefannothing = 1
					
					player.mo.stefanaccept = 1
				elseif (player.cmd.buttons & BT_SPIN)
				and player.mo.stefanpoint == 5
				and player.mo.stefancancel == 0
				and player.stefannothing == 1
					player.stefannothing = 0
					
					player.mo.stefancancel = 1
				end
				//
				if (player.cmd.forwardmove > 25)
					player.mo.stefanmenu_press = 1
				else
					player.mo.stefanmenu_press = 0
				end
				if (player.cmd.forwardmove < -25)
					player.mo.stefanmenu_press2 = 1
				else
					player.mo.stefanmenu_press2 = 0
				end
				if not (player.cmd.buttons & BT_JUMP)
					player.mo.stefanaccept = 0
				end
				if not ((player.cmd.buttons & BT_SPIN) or (player.cmd.buttons & BT_USE))
					player.mo.stefancancel = 0
				end
				player.cmd.forwardmove = 0
				player.cmd.sidemove = 0
				player.cmd.buttons = 0
			end
		end
	end
end)

print("\n"+"\x89\Stefan The Fox \x80\- \x88\Sprites by Pupsik228", "\x87\Coding by Mr.FondusBroMan", "\x81\Stefan The Fox V1.0")
print("\n"+"\x85"+"Stefan The Fox\x80 for [SRB2 2.2.11+]"+"\n")